<?php
include("../../begin.php");
include("../../adminlib.php");
include("../../getlang.php");
include("../../$mylanguage/admintext.php");

if (!is_dir('../../bot-trap'))
{
	mkdir('../../bot-trap');
	echo "The directory 'bot-trap' has been created.<br /><br />";
}
	else {echo "The directory 'bot-trap' already exists.<br /><br />";}

if (file_exists('../../blacklist.dat'))
{
    echo "The file 'blacklist.dat' already exists.<br /><br />";
}
else
{
		$fh = fopen('../../blacklist.dat',"x+b");
		fclose($fh);
		chmod('../../blacklist.dat',0664);
		echo "The file 'blacklist.dat' has been created.<br /><br />";
}

if (file_exists('../../robots.txt'))
{
	$key = "User-agent: *";
	$key1 = "Disallow: /bot-trap/";
	$fh = fopen('../../robots.txt',"r");
	$lines = file('../../robots.txt');
	fclose($fh);
    foreach($lines as $line)
	{
        if (stristr($line, $key)) {$agent=true;}
		if (stristr($line, $key1)) //look for bot-trap in each line
		{
			echo "The file 'robots.txt' already exists.<br /><br />";
			break;
		}
	}

	if (!stristr($line, $key1))
	{
		$fh = fopen('../../robots.txt',"w+");
		if (flock($fh, LOCK_EX))
		{
			if (!$agent)
			{
				fwrite($fh, $key . "\r\n"); //insert User-agent;
				fwrite($fh, $key1 . "\r\n"); //insert disallow bot-trap after User-agent;
			}
			foreach($lines as $line)
			{
				fwrite($fh, $line); //place lines back in file
				if (stristr($line, $key) and ($agent)) //look for user agent in each line
				{
					fwrite($fh, $key1 . "\r\n"); //insert disallow bot-trap after User-agent;
				}
			}
			flock($fh, LOCK_UN);
			fclose($fh);
			echo "The file 'robots.txt' was modified to add 'Disallow: /bot-trap'.<br /><br />";
		}
			else
			{
				echo "Couldn't get lock for 'robots.txt'. Manually add 'Disallow: /bot-trap' to the robots.txt file.<br /><br />";
			}
	}
}

if (!file_exists('../../robots.txt'))
{
		$fh = fopen('../../robots.txt',"x+b");
		fwrite($fh,'User-agent: *
Disallow: /bot-trap/');
		fclose($fh);
		chmod('../../robots.txt',0664);
		echo "The file 'robots.txt' has been created.<br /><br />";
}

if (file_exists('../../.htaccess'))
{
	$key = "</RequireAll>";
	$fh = fopen('../../.htaccess','r');
	$lines = file('../../.htaccess');
	fclose($fh);
	
    foreach($lines as $line)
	{
        if (stristr($line, $key)) //look is see if RequireAll exists
		{
			echo "The file '.htaccess' already exists.<br /><br />You may proceed with installation.";
			break;
		}
		elseif ($line === end($lines))
		{
			$fh = fopen('../../.htaccess',"a+");
			fwrite($fh, "\r\n\n" . "# Access file for Apache 2.4 - Modified by Bot-trap" . "\n" . "<RequireAll>" . "\n" . "	Require all granted" . "\n" . "    # Anthing below this line was added by Bot-trap" . "\n" . "</RequireAll>");
			fclose($fh);
			echo "The file '.htaccess' has been modified.<br /><br />You may proceed with installation.";
		}
	}
}

if (!file_exists('../../.htaccess'))
{
	$fh = fopen('../../.htaccess',"x+");
	fwrite($fh, "# Access file for Apache 2.4 - Created by Bot-trap" . "\n" . "<RequireAll>" . "\n" . "	Require all granted" . "\r\n" . "    # Anthing below this line was added by Bot-trap" . "\n" . "</RequireAll>");
	fclose($fh);
	chmod('../../.htaccess',0664);
	echo "The file '.htaccess' has been created.<br /><br />You may proceed with installation.";
}
?>